## mingw-w64-vtk-9.5.2-1.src.tar.zst

=== IO/Legacy/CMakeLists.txt ===
set(classes
  vtkCompositeDataReader
  vtkCompositeDataWriter
  vtkDataObjectReader
  vtkDataObjectWriter
  vtkDataReader
  vtkDataSetReader
  vtkDataSetWriter
  vtkDataWriter
  vtkGenericDataObjectReader
  vtkGenericDataObjectWriter
  vtkGraphReader
  vtkGraphWriter
  vtkLegacyCellGridReader
  vtkLegacyCellGridWriter
  vtkPixelExtentIO
  vtkPolyDataReader
  vtkPolyDataWriter
  vtkRectilinearGridReader
  vtkRectilinearGridWriter
  vtkSimplePointsReader
  vtkSimplePointsWriter
  vtkStructuredGridReader
  vtkStructuredGridWriter
  vtkStructuredPointsReader
  vtkStructuredPointsWriter
  vtkTableReader
  vtkTableWriter
  vtkTreeReader
  vtkTreeWriter
  vtkUnstructuredGridReader
  vtkUnstructuredGridWriter)

vtk_module_add_module(VTK::IOLegacy
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IOLegacy)

=== IO/PostgreSQL/CMakeLists.txt ===
vtk_module_find_package(PRIVATE_IF_SHARED
  PACKAGE PostgreSQL)

set(classes
  vtkPostgreSQLDatabase
  vtkPostgreSQLQuery
  vtkPostgreSQLToTableReader
  vtkTableToPostgreSQLWriter)

vtk_module_add_module(VTK::IOPostgreSQL
  CLASSES ${classes}
  SOURCES vtkIOPostgreSQL_AutoInit.cxx)

vtk_module_link(VTK::IOPostgreSQL
  NO_KIT_EXPORT_IF_SHARED
  PRIVATE
    PostgreSQL::PostgreSQL)
vtk_add_test_mangling(VTK::IOPostgreSQL)

=== Parallel/DIY/CMakeLists.txt ===
set(classes
  vtkDIYDataExchanger
  vtkDIYExplicitAssigner
  vtkDIYGhostUtilities
  vtkDIYUtilities)

set(templates
  vtkDIYGhostUtilities.txx
  vtkDIYUtilities.txx)

vtk_module_add_module(VTK::ParallelDIY
  CLASSES ${classes}
  TEMPLATES ${templates})

vtk_module_definitions(VTK::ParallelDIY
  PUBLIC DIY_NO_THREADS)
vtk_add_test_mangling(VTK::ParallelDIY)

=== Rendering/SceneGraph/CMakeLists.txt ===
set(classes
  vtkActorNode
  vtkCameraNode
  vtkLightNode
  vtkMapperNode
  vtkPolyDataMapperNode
  vtkRendererNode
  vtkViewNode
  vtkViewNodeFactory
  vtkVolumeMapperNode
  vtkVolumeNode
  vtkWindowNode)

vtk_module_add_module(VTK::RenderingSceneGraph
  CLASSES ${classes})
vtk_add_test_mangling(VTK::RenderingSceneGraph)

=== ThirdParty/hdf5/CMakeLists.txt ===
set(HDF5_EXTERNALLY_CONFIGURED 1)

vtk_module_third_party(
  INTERNAL
    LICENSE_FILES
      "vtkhdf5/COPYING"
      "vtkhdf5/COPYING_LBNL_HDF5"
    SPDX_LICENSE_IDENTIFIER
      "BSD-3-Clause"
    SPDX_COPYRIGHT_TEXT
      "Copyright 2006 by The HDF Group."
      "Copyright 1998-2006 by The Board of Trustees of the University of Illinois."
      "Copyright (c) 2016, The Regents of the University of California, through Lawrence Berkeley National Laboratory (subject to receipt of any required approvals from the U.S. Dept. of Energy)."
    SPDX_DOWNLOAD_LOCATION
      "git+https://gitlab.kitware.com/third-party/hdf5.git@for/vtk-20220414-1.13.1"
    VERSION
      "1.13.1"
    STANDARD_INCLUDE_DIRS
    INTERFACE
  EXTERNAL
    PACKAGE       HDF5
    COMPONENTS    C HL
    TARGETS       hdf5::hdf5
                  hdf5::hdf5_hl
    USE_VARIABLES HDF5_IS_PARALLEL
    STANDARD_INCLUDE_DIRS)

set(vtkhdf5_is_parallel 0)
if (VTK_MODULE_USE_EXTERNAL_vtkhdf5 AND HDF5_IS_PARALLEL)
  if (NOT TARGET VTK::mpi)
    message(FATAL_ERROR
      "An external MPI-aware HDF5 requires that VTK be built with MPI support "
      "as well.")
  endif ()

  set(vtkhdf5_is_parallel 1)
  vtk_module_link(VTK::hdf5
    INTERFACE
      VTK::mpi)
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtk_hdf5.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtk_hdf5.h")

vtk_module_install_headers(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/vtk_hdf5.h")

=== ThirdParty/libxml2/CMakeLists.txt ===
vtk_module_third_party(
  INTERNAL
    LICENSE_FILES
      "vtklibxml2/Copyright"
    SPDX_LICENSE_IDENTIFIER
      "MIT"
    SPDX_COPYRIGHT_TEXT
      "Copyright (C) 1998-2012 Daniel Veillard"
    SPDX_DOWNLOAD_LOCATION
      "git+https://gitlab.kitware.com/third-party/libxml2.git@for/vtk-20241206-2.13.5"
    VERSION
      "2.13.5"
    STANDARD_INCLUDE_DIRS
  EXTERNAL
    PACKAGE LibXml2
    TARGETS LibXml2::LibXml2
    STANDARD_INCLUDE_DIRS)

include(vtkDetectLibraryType)
vtk_detect_library_shared(vtklibxml2 LibXml2::LibXml2)

if (vtklibxml2_is_shared)
  set(LIBXML_STATIC 0)
else ()
  set(LIBXML_STATIC 1)
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtk_libxml2.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtk_libxml2.h")

vtk_module_install_headers(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/vtk_libxml2.h")

=== ThirdParty/mpi4py/CMakeLists.txt ===
vtk_module_third_party(
  INTERNAL
    LICENSE_FILES
      "vtkmpi4py/LICENSE.rst"
    SPDX_LICENSE_IDENTIFIER
      "BSD-2-Clause AND BSD-3-Clause"
    SPDX_COPYRIGHT_TEXT
      "Copyright (c) 2021, Lisandro Dalcin"
      "Copyright (c) Sandia Corporation, Kitware Inc."
    SPDX_DOWNLOAD_LOCATION
      "git+https://gitlab.kitware.com/third-party/mpi4py.git@for/vtk-20230424-3.1.4"
    VERSION
      "3.1.4"
  EXTERNAL
    PACKAGE mpi4py
    TARGETS mpi4py::mpi4py)

=== Utilities/Marshalling/CMakeLists.txt ===
find_package(Python3 QUIET COMPONENTS Interpreter)
if (Python3_FOUND)
  set(_vtk_testing_python_exe "$<TARGET_FILE:Python3::Interpreter>")
  vtk_add_test_python(
    TestMarshalHintHeaderConsistency,marshal_macro_annotate_headers.py,NO_DATA,NO_OUTPUT,NO_VALID --test)
endif ()

=== Wrapping/PythonCore/CMakeLists.txt ===
set(classes
  PyVTKEnum
  PyVTKExtras
  PyVTKNamespace
  PyVTKObject
  PyVTKSpecialObject
  PyVTKTemplate
  vtkPythonArgs
  vtkPythonCommand
  vtkPythonOverload
  vtkPythonUtil
  vtkSmartPyObject)

set(private_classes
  PyVTKMethodDescriptor
  PyVTKReference)

set(headers
  vtkPythonCompatibility.h)

set(private_headers
  PyVTKExtras.h)

get_property(vtk_python_version_major GLOBAL
  PROPERTY _vtk_python_version_major)
get_property(vtk_python_version_minor GLOBAL
  PROPERTY _vtk_python_version_minor)

vtk_module_add_module(VTK::WrappingPythonCore
  CLASSES ${classes}
  HEADERS ${headers}
  PRIVATE_CLASSES ${private_classes}
  PRIVATE_HEADERS ${private_headers}
  LIBRARY_NAME_SUFFIX "${vtk_python_version_major}.${vtk_python_version_minor}")

if (NOT VTK_ABI_NAMESPACE_NAME STREQUAL "<DEFAULT>" AND NOT DEFINED ENV{CI})
  message(WARNING "Wrappings::PythonCore ABI does not not support the VTK_ABI_NAMESPACE_NAME "
                  "and the symbols will not be mangled.")
endif ()

if (Python3_VERSION VERSION_LESS "3.7" AND NOT CMAKE_VERSION VERSION_LESS "3.19")
  include(CheckCompilerFlag)
  set(old_python_ignore_warning_flag "-Wno-writable-strings")
  check_compiler_flag(CXX "${old_python_ignore_warning_flag}" "vtk_have_compiler_flag-CXX-${old_python_ignore_warning_flag}")
  if (vtk_have_compiler_flag-CXX-${old_python_ignore_warning_flag})
    vtk_module_compile_options(VTK::WrappingPythonCore
      PRIVATE
        "${old_python_ignore_warning_flag}")
  endif ()
endif ()

=== IO/CatalystConduit/Catalyst/CMakeLists.txt ===
if (WIN32)
  set(catalyst_library_destination
    "${_vtk_build_RUNTIME_DESTINATION}/catalyst")
else ()
  set(catalyst_library_destination
    "${_vtk_build_LIBRARY_DESTINATION}/catalyst")
  file(RELATIVE_PATH _catalyst_impl_relpath
    "/prefix/${catalyst_library_destination}"
    "/prefix/${_vtk_build_LIBRARY_DESTINATION}")
  if (APPLE)
    set(catalyst_rel_rpath
      "@loader_path/${_catalyst_impl_relpath}")
  else ()
    set(catalyst_rel_rpath
      "$ORIGIN/${_catalyst_impl_relpath}")
  endif ()

  list(APPEND CMAKE_INSTALL_RPATH
    "${catalyst_rel_rpath}")
endif ()

catalyst_implementation(
  NAME    vtk
  TARGET  catalyst-vtk
  EXPORT "${_vtk_build_INSTALL_EXPORT}"
  LIBRARY_DESTINATION
    "${catalyst_library_destination}"
  SOURCES
    VTKCatalyst.cxx
  CATALYST_TARGET VTK::catalyst)

add_library(VTK::catalyst-vtk ALIAS catalyst-vtk)

# Clear the `-pvVERSION` suffix (if any).
set(_vtk_build_LIBRARY_NAME_SUFFIX "")
# Clear version information.
set(_vtk_build_VERSION "")
set(_vtk_build_SOVERSION "")

=== ThirdParty/lzma/vtklzma/CMakeLists.txt ===
# liblzma wrapped for VTK by Quincy Wofford and John Patchett,
# Los Alamos National Laboratory (2017).
# Thanks to Lasse Collin for integration help

if (FALSE) # XXX(kitware): hide subprojects.
project(LZMA VERSION 5.2.5 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LZMA compression library")
endif ()

# XXX(kitware): avoid quoted variable policy warning from CMake.
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID STREQUAL "Clang")
  SET(GNU_COMPATIBLE_COMPILER 1)
ENDIF()

include(TestBigEndian)
include(CheckIncludeFile)
include(CheckTypeSize)
include(ProcessorCount)

test_big_endian(WORDS_BIGENDIAN)

check_include_file("strings.h" HAVE_STRINGS_H)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_include_file("sys/endian.h" HAVE_SYS_ENDIAN_H)
if (HAVE_BYTESWAP_H)
  check_symbol_exists(HAVE_BSWAP_16 "byteswap.h" bswap_16)
  check_symbol_exists(HAVE_BSWAP_32 "byteswap.h" bswap_32)
  check_symbol_exists(HAVE_BSWAP_64 "byteswap.h" bswap_64)
endif ()

check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("limits.h" HAVE_LIMITS_H)
check_include_file("stdbool.h" HAVE_STDBOOL_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_type_size(int16_t INT16_T)
check_type_size(int32_t INT32_T)
check_type_size(int64_t INT64_T)
check_type_size(intmax_t INTMAX_T)
check_type_size(uint8_t UINT8_T)
check_type_size(uint16_t UINT16_T)
check_type_size(uint32_t UINT32_T)
check_type_size(uint64_t UINT64_T)
check_type_size(uintmax_t UINTMAX_T)

check_type_size("short" SIZE_OF_SHORT)
check_type_size("int" SIZE_OF_INT)
check_type_size("long" SIZE_OF_LONG)
check_type_size("long long" SIZE_OF_LONG_LONG)

check_type_size("unsigned short" SIZE_OF_UNSIGNED_SHORT)
check_type_size("unsigned" SIZE_OF_UNSIGNED)
check_type_size("unsigned long" SIZE_OF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZE_OF_UNSIGNED_LONG_LONG)
check_type_size("size_t" SIZE_OF_SIZE_T)

check_type_size("__int64" __INT64)
check_type_size("unsigned __int64" UNSIGNED___INT64)

check_type_size(uintptr_t UINTPTR_T)
IF(NOT HAVE_UINTPTR_T)
  IF("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
    SET(uintptr_t "uint64_t")
  ELSE()
    SET(uintptr_t "uint32_t")
  ENDIF()
ENDIF()

# We will need to add some encoder/decoder checking here
set(HAVE_DECODER_ARM 1)
set(HAVE_DECODER_ARMTHUMB 1)
set(HAVE_DECODER_DELTA 1)
set(HAVE_DECODER_IA64 1)
set(HAVE_DECODER_LZMA1 1)
set(HAVE_DECODER_LZMA2 1)
set(HAVE_DECODER_POWERPC 1)
set(HAVE_DECODER_SPARC 1)
set(HAVE_DECODER_X86 1)
set(HAVE_DECODERS 1)

set(HAVE_ENCODER_ARM 1)
set(HAVE_ENCODER_ARMTHUMB 1)
set(HAVE_ENCODER_DELTA 1)
set(HAVE_ENCODER_IA64 1)
set(HAVE_ENCODER_LZMA1 1)
set(HAVE_ENCODER_LZMA2 1)
set(HAVE_ENCODER_POWERPC 1)
set(HAVE_ENCODER_SPARC 1)
set(HAVE_ENCODER_X86 1)
set(HAVE_ENCODERS 1)

set(HAVE_MF_BT2 1)
set(HAVE_MF_BT3 1)
set(HAVE_MF_BT4 1)
set(HAVE_MF_HC3 1)
set(HAVE_MF_HC4 1)

# Define some checks
set(HAVE_CHECK_CRC32 1)
set(HAVE_CHECK_CRC64 1)
set(HAVE_CHECK_SHA256 1)
set(HAVE_DECODERS 1)

# Performance optimization
set(TUKLIB_FAST_UNALIGNED_ACCESS 1)
# Additional required mangling (var used by liblzma during build)
set(TUKLIB_SYMBOL_PREFIX vtklzma_)

find_package(Threads REQUIRED)
if (CMAKE_USE_WIN32_THREADS_INIT)
  set(MYTHREAD_VISTA 1)
elseif (CMAKE_USE_PTHREADS_INIT)
  set(MYTHREAD_POSIX 1)
else ()
  message(FATAL_ERROR
    "Unsupported threading backend for LZMA.")
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h")
add_definitions(-DHAVE_CONFIG_H)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/api
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/check
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lz
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/simple
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/delta
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/rangecoder
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common)

set(sources
  src/common/tuklib_cpucores.c
  src/common/tuklib_physmem.c
  src/liblzma/check/check.c
  src/liblzma/check/crc32_fast.c
  src/liblzma/check/crc32_table.c
  src/liblzma/check/crc64_fast.c
  src/liblzma/check/crc64_table.c
  src/liblzma/check/sha256.c
  src/liblzma/common/alone_decoder.c
  src/liblzma/common/alone_encoder.c
  src/liblzma/common/auto_decoder.c
  src/liblzma/common/block_buffer_decoder.c
  src/liblzma/common/block_buffer_encoder.c
  src/liblzma/common/block_decoder.c
  src/liblzma/common/block_encoder.c
  src/liblzma/common/block_header_decoder.c
  src/liblzma/common/block_header_encoder.c
  src/liblzma/common/block_util.c
  src/liblzma/common/common.c
  src/liblzma/common/easy_buffer_encoder.c
  src/liblzma/common/easy_decoder_memusage.c
  src/liblzma/common/easy_encoder.c
  src/liblzma/common/easy_encoder_memusage.c
  src/liblzma/common/easy_preset.c
  src/liblzma/common/filter_buffer_decoder.c
  src/liblzma/common/filter_buffer_encoder.c
  src/liblzma/common/filter_common.c
  src/liblzma/common/filter_decoder.c
  src/liblzma/common/filter_encoder.c
  src/liblzma/common/filter_flags_decoder.c
  src/liblzma/common/filter_flags_encoder.c
  src/liblzma/common/hardware_cputhreads.c
  src/liblzma/common/hardware_physmem.c
  src/liblzma/common/index.c
  src/liblzma/common/index_decoder.c
  src/liblzma/common/index_encoder.c
  src/liblzma/common/index_hash.c
  src/liblzma/common/outqueue.c
  src/liblzma/common/stream_buffer_decoder.c
  src/liblzma/common/stream_buffer_encoder.c
  src/liblzma/common/stream_decoder.c
  src/liblzma/common/stream_encoder.c
  src/liblzma/common/stream_encoder_mt.c
  src/liblzma/common/stream_flags_common.c
  src/liblzma/common/stream_flags_decoder.c
  src/liblzma/common/stream_flags_encoder.c
  src/liblzma/common/vli_decoder.c
  src/liblzma/common/vli_encoder.c
  src/liblzma/common/vli_size.c
  src/liblzma/delta/delta_common.c
  src/liblzma/delta/delta_decoder.c
  src/liblzma/delta/delta_encoder.c
  src/liblzma/lzma/fastpos_table.c
  src/liblzma/lzma/lzma2_decoder.c
  src/liblzma/lzma/lzma2_encoder.c
  src/liblzma/lzma/lzma_decoder.c
  src/liblzma/lzma/lzma_encoder.c
  src/liblzma/lzma/lzma_encoder_optimum_fast.c
  src/liblzma/lzma/lzma_encoder_optimum_normal.c
  src/liblzma/lzma/lzma_encoder_presets.c
  src/liblzma/lz/lz_decoder.c
  src/liblzma/lz/lz_encoder.c
  src/liblzma/lz/lz_encoder_mf.c
  src/liblzma/rangecoder/price_table.c
  src/liblzma/simple/arm.c
  src/liblzma/simple/armthumb.c
  src/liblzma/simple/ia64.c
  src/liblzma/simple/powerpc.c
  src/liblzma/simple/simple_coder.c
  src/liblzma/simple/simple_decoder.c
  src/liblzma/simple/simple_encoder.c
  src/liblzma/simple/sparc.c
  src/liblzma/simple/x86.c)

set(private_headers
  src/common/mythread.h
  src/common/sysdefs.h
  src/common/tuklib_common.h
  src/common/tuklib_config.h
  src/common/tuklib_cpucores.h
  src/common/tuklib_integer.h
  src/common/tuklib_physmem.h
  src/liblzma/check/check.h
  src/liblzma/check/crc32_table_be.h
  src/liblzma/check/crc32_table_le.h
  src/liblzma/check/crc64_table_be.h
  src/liblzma/check/crc64_table_le.h
  src/liblzma/check/crc_common.h
  src/liblzma/common/alone_decoder.h
  src/liblzma/common/block_buffer_encoder.h
  src/liblzma/common/block_decoder.h
  src/liblzma/common/block_encoder.h
  src/liblzma/common/common.h
  src/liblzma/common/easy_preset.h
  src/liblzma/common/filter_common.h
  src/liblzma/common/filter_decoder.h
  src/liblzma/common/filter_encoder.h
  src/liblzma/common/index.h
  src/liblzma/common/index_encoder.h
  src/liblzma/common/memcmplen.h
  src/liblzma/common/outqueue.h
  src/liblzma/common/stream_decoder.h
  src/liblzma/common/stream_flags_common.h
  src/liblzma/delta/delta_common.h
  src/liblzma/delta/delta_decoder.h
  src/liblzma/delta/delta_encoder.h
  src/liblzma/delta/delta_private.h
  src/liblzma/lzma/fastpos.h
  src/liblzma/lzma/lzma2_decoder.h
  src/liblzma/lzma/lzma2_encoder.h
  src/liblzma/lzma/lzma_common.h
  src/liblzma/lzma/lzma_decoder.h
  src/liblzma/lzma/lzma_encoder.h
  src/liblzma/lzma/lzma_encoder_private.h
  src/liblzma/lz/lz_decoder.h
  src/liblzma/lz/lz_encoder.h
  src/liblzma/lz/lz_encoder_hash.h
  src/liblzma/lz/lz_encoder_hash_table.h
  src/liblzma/rangecoder/price.h
  src/liblzma/rangecoder/range_common.h
  src/liblzma/rangecoder/range_decoder.h
  src/liblzma/rangecoder/range_encoder.h
  src/liblzma/simple/simple_coder.h
  src/liblzma/simple/simple_decoder.h
  src/liblzma/simple/simple_encoder.h
  src/liblzma/simple/simple_private.h)

set(headers
  src/liblzma/api/lzma.h
  src/liblzma/api/lzma/base.h
  src/liblzma/api/lzma/bcj.h
  src/liblzma/api/lzma/block.h
  src/liblzma/api/lzma/check.h
  src/liblzma/api/lzma/container.h
  src/liblzma/api/lzma/delta.h
  src/liblzma/api/lzma/filter.h
  src/liblzma/api/lzma/hardware.h
  src/liblzma/api/lzma/index.h
  src/liblzma/api/lzma/index_hash.h
  src/liblzma/api/lzma/lzma12.h
  src/liblzma/api/lzma/stream_flags.h
  src/liblzma/api/lzma/version.h
  src/liblzma/api/lzma/vli.h
  src/liblzma/api/vtk_lzma_mangle.h)

vtk_module_add_module(VTK::lzma
  HEADER_DIRECTORIES
  SOURCES ${sources}
  HEADERS ${headers}
  PRIVATE_HEADERS ${private_headers}
  HEADERS_SUBDIR "vtklzma")
set_target_properties(lzma
  PROPERTIES
    C_STANDARD 99
    POSITION_INDEPENDENT_CODE 1)

if (BUILD_SHARED_LIBS)
  set_target_properties(lzma
    PROPERTIES
      DEFINE_SYMBOL DLL_EXPORT)
  if (CMAKE_USE_PTHREADS_INIT)
    target_link_libraries(lzma
      PRIVATE
        ${CMAKE_THREAD_LIBS_INIT})
  endif ()
endif ()

=== Filters/Parallel/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkFiltersParallelCxxTests testsStd
  TestAlignImageDataSetFilter.cxx,NO_VALID
  TestAngularPeriodicFilter.cxx
  TestGaussianQuadratureIntegration.cxx,NO_VALID
  TestPOutlineFilter.cxx,NO_VALID
  )
vtk_test_cxx_executable(vtkFiltersParallelCxxTests testsStd)

if (TARGET VTK::ParallelMPI)
  set(vtkFiltersParallelCxxTests-MPI_NUMPROCS 2)
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI tests
    TESTING_DATA
    DistributedData.cxx
    DistributedDataRenderPass.cxx
    PTextureMapToSphere.cxx
    TestPHyperTreeGridProbeFilter.cxx
    TestPExtractDataArraysOverTime.cxx,NO_VALID
    TestPartitionBalancer.cxx,NO_VALID
    TransmitImageData.cxx
    TransmitImageDataRenderPass.cxx
    TransmitRectilinearGrid.cxx
    TransmitStructuredGrid.cxx
    )
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI no_data_tests
    ParallelResampling.cxx
    UnitTestPMaskPoints.cxx
    TestGenerateProcessIds.cxx,NO_VALID
    TestGenerateProcessIdsHTG.cxx,NO_VALID
    TestPAxisAlignedReflectionFilter.cxx,NO_VALID
    TestPOutlineFilter.cxx,NO_VALID
    )

  # We want 4 processes to test the vtkAggregateDataSetFilter
  # and vtkHyperTreeGridGhostCellsGenerator properly
  set(vtkFiltersParallelCxxTests-MPI_NUMPROCS 4)
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI no_data_tests_4_procs
    AggregateDataSet.cxx
    TestGenerateGlobalIdsHTG.cxx,NO_VALID
  )
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI tests_4_procs
    TESTING_DATA
    TestHyperTreeGridGhostCellsGenerator.cxx,NO_VALID
  )


  set(all_tests
    ${tests}
    ${no_data_tests}
    ${no_data_tests_4_procs}
    ${tests_4_procs}
    )
  vtk_test_cxx_executable(vtkFiltersParallelCxxTests-MPI all_tests)
endif()

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>
# Contributor: Mario Emmenlauer <memmenlauer@biodataanalysis.de>

_realname=vtk
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=9.5.2
pkgrel=1
pkgdesc="A software system for 3D computer graphics, image processing and visualization (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.vtk.org/"
msys2_repository_url="https://gitlab.kitware.com/vtk/vtk"
msys2_references=(
  'archlinux: vtk'
  "cpe: cpe:/a:vtk:vtk"
)
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo \
           "${MINGW_PACKAGE_PREFIX}-verdict" \
           "${MINGW_PACKAGE_PREFIX}-viskores")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-alembic"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-anari-sdk" \
               "${MINGW_PACKAGE_PREFIX}-scnlib")
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-fontconfig"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-libxml2"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             # "${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             # "${MINGW_PACKAGE_PREFIX}-tk"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp"
             )
optdepends=("${MINGW_PACKAGE_PREFIX}-adios2: I/O ADIOS2"
            "${MINGW_PACKAGE_PREFIX}-alembic: I/O Alembic"
            "${MINGW_PACKAGE_PREFIX}-boost-libs: InfovisBoost and InfovisBoostGraphAlgorithms modules"
            "${MINGW_PACKAGE_PREFIX}-cgns: CGNS Reader"
            "${MINGW_PACKAGE_PREFIX}-ffmpeg: I/O FFMPEG"
            "${MINGW_PACKAGE_PREFIX}-fontconfig: Fontconfig Rendering"
            "${MINGW_PACKAGE_PREFIX}-gdal: I/O GDAL"
            "${MINGW_PACKAGE_PREFIX}-gl2ps: PS Rendering"
            "${MINGW_PACKAGE_PREFIX}-hdf5: I/O HDF5"
            "${MINGW_PACKAGE_PREFIX}-liblas: I/O LAS"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: I/O MySQL/MariaDB"
            "${MINGW_PACKAGE_PREFIX}-libpng: I/O PNG Images"
            "${MINGW_PACKAGE_PREFIX}-libogg: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libtheora: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libxml2: I/O Infovis"
            "${MINGW_PACKAGE_PREFIX}-netcdf: I/O netCDF"
            "${MINGW_PACKAGE_PREFIX}-opencascade: I/O OCCT"
            "${MINGW_PACKAGE_PREFIX}-openslide: DomainsMicroscopy"
            "${MINGW_PACKAGE_PREFIX}-openturns: OpenTURNS Filter"
            "${MINGW_PACKAGE_PREFIX}-openvdb: I/O OpenVDB"
            "${MINGW_PACKAGE_PREFIX}-openvr: OpenVR Rendering"
            "${MINGW_PACKAGE_PREFIX}-pdal: I/O PDAL"
            "${MINGW_PACKAGE_PREFIX}-postgresql: I/O PostgreSQL"
            "${MINGW_PACKAGE_PREFIX}-proj: GEOVis"
            "${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib: Matplotlib renderer"
            "${MINGW_PACKAGE_PREFIX}-qt6-base: Qt Rendering"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Qt Qml plugin"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: I/O SQL"
            # "${MINGW_PACKAGE_PREFIX}-tk: TCL bindings, Python Tk widgets"
            "${MINGW_PACKAGE_PREFIX}-unixodbc")
if [[ ${MSYSTEM} != MINGW64 ]]; then
  optdepends+=("${MINGW_PACKAGE_PREFIX}-anari-sdk: ANARI Rendering")
fi
source=(https://www.vtk.org/files/release/${pkgver%.*}/VTK-${pkgver}.tar.gz
        "001-no-exact-version-for-fast_float.patch"
        "004-accept-future-versions-of-boost-and-occ.patch"
        "007-dll-export-some-functions.patch")
sha256sums=('cee64b98d270ff7302daf1ef13458dff5d5ac1ecb45d47723835f7f7d562c989'
            'a978ec60b9ef3a9a19265b4e502a602cff016a5cbfc7801398dc1f2f7206a1d9'
            'a44b3ba4bdc02be4767ff48b8a7fd4206a53756a881421fca99f538b08a7b48c'
            '61c334b3050f675ee65f92163719da3e75688e490971ffcc9c4cd95eb90d762a')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-no-exact-version-for-fast_float.patch \
    004-accept-future-versions-of-boost-and-occ.patch

  # Succeeds with Clang but fails with GCC!
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      007-dll-export-some-functions.patch
  fi
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_ENABLE_VTK_RenderingAnari=NO"
                    "-DVTK_MODULE_USE_EXTERNAL_VTK_scn=OFF"
                    "-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF"
                    "-DVTK_MODULE_USE_EXTERNAL_VTK_vtkviskores=OFF")
  fi

  CFLAGS+=" ${CPPFLAGS}"
  CXXFLAGS+=" ${CPPFLAGS} -D_USE_MATH_DEFINES -w"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_INSTALL_LICENSEDIR=share/licenses/vtk \
    -DBUILD_SHARED_LIBS=ON \
    -DPython3_EXECUTABLE="${MINGW_PREFIX}/bin/python.exe" \
    -DVTK_BUILD_TESTING=OFF \
    -DVTK_VERSIONED_INSTALL=OFF \
    -DVTK_BUILD_ALL_MODULES=ON \
    -DVTK_GROUP_ENABLE_MPI=NO \
    -DVTK_GROUP_ENABLE_Web=NO \
    -DVTK_MODULE_ENABLE_VTK_FiltersParallelVerdict=WANT \
    -DVTK_MODULE_ENABLE_VTK_FiltersTemporal=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOERF=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOFDS=WANT \
    -DVTK_MODULE_ENABLE_VTK_RenderingOpenXRRemoting=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingZSpace=NO \
    -DVTK_USE_EXTERNAL=ON \
    -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
    -DVTK_WRAP_JAVA=OFF \
    -DVTK_WRAP_PYTHON=ON \
    -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
    -DVTK_SMP_ENABLE_SEQUENTIAL=ON \
    -DVTK_SMP_ENABLE_STDTHREAD=ON \
    -DVTK_SMP_ENABLE_OPENMP=ON \
    -DVTK_USE_VIDEO_FOR_WINDOWS=ON \
    -DVTK_ENABLE_OSPRAY=OFF \
    -DVTK_ENABLE_REMOTE_MODULES=OFF \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/Copyright.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # Remove third party CMake patching for older versions than ours
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/patches/3.{1{3,6,9},2{0,2,3}}
}
